package edu.ntnu.stud.chaosgame;

import edu.ntnu.stud.chaosgame.game.ChaosGameDescription;
import edu.ntnu.stud.chaosgame.game.ChaosGameFileHandler;
import edu.ntnu.stud.chaosgame.model.Matrix2x2;
import edu.ntnu.stud.chaosgame.model.Vector2D;
import edu.ntnu.stud.chaosgame.model.handling.ChaosCanvas;
import edu.ntnu.stud.chaosgame.model.handling.ChaosGame;
import edu.ntnu.stud.chaosgame.model.transformations.AffineTransform2D;
import edu.ntnu.stud.chaosgame.model.transformations.Transform2D;
import java.util.ArrayList;
import java.util.List;

/**
 * Main class for the Chaos Game application.
 */
public class Main {

  public static void main(String[] args) {
    System.out.println("Hi");
    String path = "src/main/resources/descriptions/TestDescription.txt";

    Vector2D minCoords = new Vector2D(0, 0);
    Vector2D maxCoords = new Vector2D(1, 1);

    Matrix2x2 transformMatrix1 = new Matrix2x2(0.5, 0, 0, 0.5);


    Vector2D translationVector1 = new Vector2D(0, 0);
    Vector2D translationVector2 = new Vector2D(0.25, 0.5);
    Vector2D translationVector3 = new Vector2D(0.5, 0);

    AffineTransform2D affineTransform1 = new AffineTransform2D(transformMatrix1, translationVector1);
    AffineTransform2D affineTransform2 = new AffineTransform2D(transformMatrix1, translationVector2);
    AffineTransform2D affineTransform3 = new AffineTransform2D(transformMatrix1, translationVector3);

    List<Transform2D> transforms = new ArrayList<>();
    transforms.add(affineTransform1);
    transforms.add(affineTransform2);
    transforms.add(affineTransform3);

    ChaosGameDescription description = null; // Declare description
    ChaosGame game = null;

    try {
      //ChaosGameDescription description = new ChaosGameFileHandler().readFromFile(path);
      description = new ChaosGameDescription(minCoords, maxCoords, transforms);
      System.out.println("MaxCoords-object of description: " + description.getMaxCoords());
      ChaosCanvas canvas = new ChaosCanvas(100, 100, description.getMinCoords(), description.getMaxCoords()); // Create canvas
      game = new ChaosGame(description, canvas);

    } catch (Exception e) {
      System.out.println(e.getMessage()); // TODO: Alter error handling
    }
    game.runSteps(100000);



  }
}